Index: /branches/HTM-DEV-0.3-dev1/build/linux/lib/TLibCommon/makefile
===================================================================
--- /branches/HTM-DEV-0.3-dev1/build/linux/lib/TLibCommon/makefile	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/build/linux/lib/TLibCommon/makefile	(revision 459)
@@ -55,4 +55,5 @@
 			$(OBJ_DIR)/TComInterpolationFilter.o \
 			$(OBJ_DIR)/libmd5.o \
+			$(OBJ_DIR)/TComWedgelet.o \
 			$(OBJ_DIR)/TComWeightPrediction.o \
 			$(OBJ_DIR)/TComRdCostWeightPrediction.o \
Index: /branches/HTM-DEV-0.3-dev1/build/vc10/TLibCommon_vc10.vcxproj
===================================================================
--- /branches/HTM-DEV-0.3-dev1/build/vc10/TLibCommon_vc10.vcxproj	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/build/vc10/TLibCommon_vc10.vcxproj	(revision 459)
@@ -166,4 +166,5 @@
     <ClCompile Include="..\..\source\Lib\TLibCommon\TComSlice.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibCommon\TComTrQuant.cpp" />
+    <ClCompile Include="..\..\source\Lib\TLibCommon\TComWedgelet.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibCommon\TComWeightPrediction.cpp" />
     <ClCompile Include="..\..\source\Lib\TLibCommon\TComYuv.cpp" />
@@ -199,4 +200,5 @@
     <ClInclude Include="..\..\source\Lib\TLibCommon\TComSlice.h" />
     <ClInclude Include="..\..\source\Lib\TLibCommon\TComTrQuant.h" />
+    <ClInclude Include="..\..\source\Lib\TLibCommon\TComWedgelet.h" />
     <ClInclude Include="..\..\source\Lib\TLibCommon\TComWeightPrediction.h" />
     <ClInclude Include="..\..\source\Lib\TLibCommon\TComYuv.h" />
Index: /branches/HTM-DEV-0.3-dev1/build/vc8/TLibCommon_vc8.vcproj
===================================================================
--- /branches/HTM-DEV-0.3-dev1/build/vc8/TLibCommon_vc8.vcproj	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/build/vc8/TLibCommon_vc8.vcproj	(revision 459)
@@ -369,4 +369,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TComWedgelet.cpp"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComWeightPrediction.cpp"
 				>
@@ -499,4 +503,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TComWedgelet.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComWeightPrediction.h"
 				>
Index: /branches/HTM-DEV-0.3-dev1/build/vc9/TLibCommon_vc9.vcproj
===================================================================
--- /branches/HTM-DEV-0.3-dev1/build/vc9/TLibCommon_vc9.vcproj	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/build/vc9/TLibCommon_vc9.vcproj	(revision 459)
@@ -372,4 +372,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TComWedgelet.cpp"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComWeightPrediction.cpp"
 				>
@@ -502,4 +506,8 @@
 			</File>
 			<File
+				RelativePath="..\..\source\Lib\TLibCommon\TComWedgelet.h"
+				>
+			</File>
+			<File
 				RelativePath="..\..\source\Lib\TLibCommon\TComWeightPrediction.h"
 				>
Index: /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_2view+depth.cfg
===================================================================
--- /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_2view+depth.cfg	(revision 459)
@@ -199,4 +199,8 @@
 #========== depth coding tools ==========
 VSO                       : 1                                      # use of view synthesis optimization for depth coding
+DMM                                : 1
+RBC                                : 1
+SDC                                : 1
+DLT                                : 1
 
 #========== view synthesis optimization (VSO) ==========
Index: /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_3view+depth.cfg
===================================================================
--- /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/baseCfg_3view+depth.cfg	(revision 459)
@@ -198,4 +198,8 @@
 #========== depth coding tools ==========
 VSO                       : 1                                      # use of view synthesis optimization for depth coding
+DMM                                : 1
+RBC                                : 1
+SDC                                : 1
+DLT                                : 1
 
 #========== view synthesis optimization (VSO) ==========
Index: /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/fullCfg.cfg
===================================================================
--- /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/fullCfg.cfg	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/cfg/3D-HEVC/fullCfg.cfg	(revision 459)
@@ -204,4 +204,8 @@
 #========== depth coding tools ==========
 VSO                       : 1                                      # use of view synthesis optimization for depth coding
+DMM                                : 1
+RBC                                : 1
+SDC                                : 1
+DLT                                : 1
 
 #========== view synthesis optimization (VSO) ==========
Index: /branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/source/App/TAppDecoder/TAppDecTop.cpp	(revision 459)
@@ -371,4 +371,7 @@
   // initialize global variables
   initROM();  
+#if H_3D_DIM_DMM
+  initWedgeLists();
+#endif
 #else
   // create decoder class
Index: /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.cpp	(revision 459)
@@ -389,4 +389,10 @@
 #if H_3D
   ("DepthFlag",             m_depthFlag          , std::vector<Int>(1,0), "Depth Flag")
+#if H_3D_DIM
+  ("DMM",                   m_useDMM,           true,  "Depth intra model modes")
+  ("RBC",                   m_useRBC,           true,  "Region boundary chain mode")
+  ("SDC",                   m_useSDC,           true,  "Simplified depth coding")
+  ("DLT",                   m_useDLT,           true,  "Depth lookup table")
+#endif
 #endif
   ("LayerIdInNuh",          m_layerIdInNuh       , std::vector<Int>(1,0), "LayerId in Nuh")
@@ -2278,4 +2284,10 @@
   printf("WVSO:%d ", m_bUseWVSO );  
 #endif
+#if H_3D_DIM
+  printf("DMM:%d ", m_useDMM );
+  printf("RBC:%d ", m_useRBC );
+  printf("SDC:%d ", m_useSDC );
+  printf("DLT:%d ", m_useDLT );
+#endif
   printf("\n\n");  
 
Index: /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.h
===================================================================
--- /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.h	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncCfg.h	(revision 459)
@@ -405,4 +405,10 @@
   TRenModSetupStrParser       m_cRenModStrParser;
 #endif
+#if H_3D_DIM
+  Bool      m_useDMM;                                        ///< flag for using DMM
+  Bool      m_useRBC;                                        ///< flag for using RBC
+  Bool      m_useSDC;                                        ///< flag for using SDC
+  Bool      m_useDLT;                                        ///< flag for using DLT
+#endif
 #endif
   // internal member functions
Index: /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncTop.cpp
===================================================================
--- /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncTop.cpp	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/source/App/TAppEncoder/TAppEncTop.cpp	(revision 459)
@@ -120,4 +120,9 @@
   xSetDirectDependencyFlags( vps );
 #if H_3D
+  for( Int layer = 0; layer < m_numberOfLayers; layer++ )
+  {
+    vps.setVpsDepthModesFlag( layer, ((vps.getDepthId( layer ) != 0) && (m_useDMM || m_useRBC || m_useSDC || m_useDLT)) ? true : false );
+  }
+
   vps.initViewIndex(); 
   m_ivPicLists.setVPS      ( &vps ); 
@@ -166,4 +171,12 @@
     m_cTEncTop.setDWeight                      ( isDepth ? m_iDWeight             : 0     );
 #endif // H_3D_VSO
+
+  //========== Depth intra modes ==========
+#if H_3D_DIM
+    m_cTEncTop.setUseDMM                       ( isDepth ? m_useDMM               : false );
+    m_cTEncTop.setUseRBC                       ( isDepth ? m_useRBC               : false );
+    m_cTEncTop.setUseSDC                       ( isDepth ? m_useSDC               : false );
+    m_cTEncTop.setUseDLT                       ( isDepth ? m_useDLT               : false );
+#endif
 #endif // H_3D
 
@@ -543,4 +556,7 @@
   // initialize global variables
   initROM();
+#if H_3D_DIM_DMM
+  initWedgeLists( true );
+#endif
 
   for( Int layer=0; layer < m_numberOfLayers; layer++)
Index: /branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/ContextTables.h
===================================================================
--- /branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/ContextTables.h	(revision 458)
+++ /branches/HTM-DEV-0.3-dev1/source/Lib/TLibCommon/ContextTables.h	(revision 459)
@@ -97,4 +97,18 @@
 #define CNU                          154      ///< dummy initialization value for unused context models 'Context model Not Used'
 
+#if H_3D_DIM
+#define NUM_DEPTH_INTRA_MODE_CTX      8       ///< number of context models for depth intra modes
+#define NUM_DDC_FLAG_CTX              2       ///< number of context models for deltaDC flag (DMM or RBC)
+#define NUM_DDC_DATA_CTX              2       ///< number of context models for deltaDC data (DMM or RBC)
+#if H_3D_DIM_DMM
+#define NUM_DMM1_DATA_CTX             1       ///< number of context models for DMM1 data
+#define NUM_DMM2_DATA_CTX             1       ///< number of context models for DMM2 data
+#define NUM_DMM3_DATA_CTX             1       ///< number of context models for DMM3 data
+#endif
+#if H_3D_DIM_RBC
+#define NUM_RBC_DATA_CTX              1       ///< number of context models for RBC data
+#endif
+#endif
+
 // ====================================================================================================================
 // Tables
@@ -334,4 +348,60 @@
   { 139,  139}, 
 };
+
+#if H_3D_DIM
+static const UChar 
+INIT_DEPTH_INTRA_MODE[3][NUM_DEPTH_INTRA_MODE_CTX] =
+{
+  {0,  0,  64,   0, CNU,   0, CNU, 0},
+  {0, 64,   0, CNU,   0, CNU,   0, 0},
+  {64, 0, CNU,   0, CNU,   0,   0, 0}
+};
+static const UChar 
+INIT_DDC_FLAG[3][NUM_DDC_FLAG_CTX] =
+{
+  {0 , CNU},
+  {0 , CNU},
+  {64, CNU}
+};
+static const UChar
+INIT_DDC_DATA[3][NUM_DDC_DATA_CTX] = 
+{
+  { CNU, CNU }, 
+  { CNU, CNU }, 
+  { CNU, CNU }, 
+};
+#if H_3D_DIM_DMM
+static const UChar
+INIT_DMM1_DATA[3][NUM_DMM1_DATA_CTX] = 
+{
+  { CNU }, 
+  { CNU }, 
+  { CNU }, 
+};
+static const UChar
+INIT_DMM2_DATA[3][NUM_DMM2_DATA_CTX] = 
+{
+  { CNU }, 
+  { CNU }, 
+  { CNU }, 
+};
+static const UChar
+INIT_DMM3_DATA[3][NUM_DMM3_DATA_CTX] = 
+{
+  { CNU }, 
+  { CNU }, 
+  { CNU }, 
+};
+#endif
+#if H_3D_DIM_RBC
+static const UChar
+INIT_RBC_DATA[3][NUM_RBC_DATA_CTX] = 
+{
+  { CNU }, 
+  { CNU }, 
+  { CNU }, 
+};
+#endif
+#endif
 //! \}
 
